function guid() {
    return s4() + s4() + '-' + s4() + '-' + s4() + '-' +
        s4() + '-' + s4() + s4() + s4();
}

function s4() {
    return Math.floor((1 + Math.random()) * 0x10000)
        .toString(16)
        .substring(1);
}

var cartManager = {
    addCart: addCart,
    removeCart: removeCart,
    getPrice: getPrice,
    getItems: getItems,
    updatePrice: updatePrice,
    clear: clear
}

function clear() {
    window.localStorage.removeItem("carts");
}

function getItems() {
    var carts = window.localStorage.getItem("carts") ? JSON.parse(window.localStorage.getItem("carts")) : {};
    return carts;
}

function addCart(item) {
    var carts = getItems();
    var exist = false;
    Object.keys(carts).forEach(function (key) {
        if (carts[key].id == item.id)
            exist = true;
    }, this);

    if (exist) {
        toastr.info('Cette élement existe déjà dans le panier')
        return false;
    }

    var id = guid();
    carts[item.key] = item;
    window.localStorage.setItem("carts", JSON.stringify(carts));

    affichageManager.showItems();

    return carts;
}

function getPrice() {
    var priceCart = 0;
    var carts = cartManager.getItems();
    Object.keys(carts).forEach(function (key) {
        priceCart += parseFloat(carts[key].price);
    }, this);

    return priceCart;
}

function removeCart(id) {
    var carts = getItems();
    delete carts[id];

    window.localStorage.setItem("carts", JSON.stringify(carts));
    return carts;
}

function getNbCart() {
    var size = 0;
    var carts = cartManager.getItems();
    Object.keys(carts).forEach(function (key) {
        size += 1;
    }, this);

    return size;
}

function updatePrice() {
    $("#cartPrice").html(cartManager.getPrice() + " €");
    $("#cartSize").html(getNbCart());
    $('#menu-cart-size').html(getNbCart());
    if(getNbCart() > 0) {
        $('#menu-cart-size').removeClass('hide');
    } else {
        $('#menu-cart-size').addClass('hide');
    }
    affichageManager.showItems();
    $(".btn-checkout").off("click").click(function (e) {
        e.preventDefault();
        if (!userConnected) {
            $("#loginModal").modal("show");
            return false;
        }
        window.location.href = Routing.generate("recap_cart", {'_locale' : local});
    });
}

affichageManager = {
    showItems: showItems
}

function showItems() {
    var items = cartManager.getItems();
    var options = "";
    Object.keys(items).forEach(function (key) {
        var item = items[key];
        if (item.licence)
            var price = '<b>' + item.licence + '</b> - ' + item.price + ' €';
        else
            price = item.price + " €";

        options += '<span class="dropdown-item" href="javascript:void(0)">'
            +'<div style="display:inline-block; vertical-align:top; width: 48px; height:48px; overflow:hidden;">'
            +'<img src="'+ item.image + '" width="64px" />'
            +'</div>'
            +'<div style="width:200px; overflow:hidden; text-overflow: ellipsis; display: inline-block; margin-left : 15px">'
            +'<b>'+ item.name + '</b><br />'
            + price
            +'</div>'
            +'<div style="display: inline-block; width: 50px; vertical-align: top;">'
            + '<button data-id="'+ key + '" class="btn btn-sm btn-danger delete-cart-item"><i class="fa fa-trash"></i></button>'
            +'</div>'
            +'</span>'
    });

    if (Object.keys(items).length) {
        options += "<div style='padding: 15px 20px;color: #555;'><b style='font-size: 18px'>Total : "+cartManager.getPrice()+" €</b></div>";
        options += "<div style='padding: 15px'><a href='javascript:void(0)' class='btn rounded primary _600 btn-checkout'>"+$('#button-validate-cart').attr('data-id')+"</button></div>";
    }
    else {
        options += "<h5 style='padding: 15px'>"+$('#no-command-cart').attr('data-id')+"</h5>";
    }

    $(".cart-items").html(options);

    $(".delete-cart-item").off('click').click(function (e) {
        e.stopPropagation();
        var id = $(this).data("id");
        cartManager.removeCart(id);
        affichageManager.showItems();

        cartManager.updatePrice();
    });
}