var locale = $('html').attr('lang');

$('#beat-content li').first().addClass('active');

var currentPlaying = $('#now-playing');
var audioPlayer = $('#audio-player');

var currentSong = $('.active.playlist-item');

function countPlayPlayer(element) {
    if (element.hasClass('active') || element.hasClass("ready-count")) {
        return;
    }
    element.addClass("ready-count");
    setTimeout(function () {
        element.removeClass("ready-count");
    }, 30 * 1000);
    element.data("play-number", element.data('play-number')+1);
    var urlCountPlay = Routing.generate("music_play", { '_locale': locale, 'id': element.data("id") });
    $.ajax({
        type: "GET",
        url: urlCountPlay,
        success: function (response) {}
    });
}

function playlistListner() {
    $('.playlist-item').click(function () {

        countPlayPlayer($(this));

        currentSong.toggleClass('active');

        currentSong = $(this);
        currentSong.toggleClass('active');

        if(String(audioPlayer[0].src).includes(currentSong.attr('audio_url'))) {
            if(audioPlayer[0].paused) {
                audioPlayer[0].play();
            } else {
                audioPlayer[0].pause();
            }
            togglePlayPause();
            togglePlayPauseList();
            toggleIconPlayPause(!audioPlayer[0].paused);
            return;
        }

        audioPlayer.attr('src', currentSong.attr('audio_url'));

        togglePlayPause();
        toggleIconPlayPause(audioPlayer[0].paused);

        audioPlayer[0].play();
        trackInformations();
    });
}

var thumbnail = $('#thumbnail');

/** update current informations on player **/

var currentLinkSharing = $('#sharing').children('a');
var currentLinkFavorite = $('#favorite').children('a');

function trackInformations() {

    if(currentSong.data("type") === "beat") {
        $(".beat-buy").css("display","block");
        $(".other-buy").css("display", "none");

        $(".buy").data("id", currentSong.data("id"));
    } else {

        $(".beat-buy").css("display","none");
        $(".other-buy").css("display", "block");

        $(".buy").data("id", currentSong.data("id"));

        $(".buy").data("url", currentSong.data("buy-song-url"));
        $(".buy").data("key", currentSong.data("id"));
        $(".buy").data("image", currentSong.attr("img_url"));
        $(".buy").data("name", currentSong.data("title"));
        $(".buy").data("type", "song");
        $(".buy").data("price", currentSong.data("price"));
        $(".buy").data("form", "mp3");
    }

    currentLinkSharing.data('id', currentSong.data('id'));
    currentLinkSharing.data("title", currentSong.data("title"));
    currentLinkSharing.data("image", currentSong.attr("img_url"));
    currentLinkSharing.data("username", currentSong.data("username"));
    currentLinkSharing.data("url", currentSong.data("detail-url"));
    currentLinkSharing.data("description", currentSong.data("description"));

    currentLinkFavorite.data('id', currentSong.data('id'));

    $('#titre-en-cours').html(currentSong.data('title'));
    $('.play-number').text(currentSong.data('play-number'));
    $('.like-number').text(currentSong.data('like-number'));

    $('.header-like').data("like-state", currentSong.data('like-state'));
    if(currentSong.data('like-state') === 0) {
        $('.header-like i').text("favorite_border")
    } else {
        $('.header-like i').text("favorite")
    }

    $('#music-ambiance').html(currentSong.data('ambiance'));
    $('#music-tag').html(currentSong.data('tag'));

    thumbnail.attr('src', currentSong.attr('img_url'));

    togglePlayPauseList();

    $(".footer .thumb").attr('src', currentSong.attr('img_url'));
    $(".footer .title").html(currentSong.data('title'));

    $(".buy-button").html(currentSong.children('.playlist-item-buy').html());
}

function togglePlayPauseList() {
    $('.playlist-item-playpause i').text("play_arrow");
    if (audioPlayer['0'].paused === true) {
        $('.active.playlist-item .playlist-item-playpause i').text("play_arrow");
    } else {
        $('.active.playlist-item .playlist-item-playpause i').text("pause");
    }
}

/** end update current informations on player**/

// Initialize audio player
audioPlayer.attr("src", currentSong.attr('audio_url'));
audioPlayer.prop("volume", 60 / 100);
trackInformations();
$('.active.playlist-item .playlist-item-playpause i').text("pause");

/** commande player header **/
var playPause = $('.play-pause');
var playButton = $('#playpause-button');
var nextButton = $('#next-button');
var previousButton = $('#previous-button');

function togglePlayPause() {
    playButton.toggleClass("d-none")
}

playPause.click(function () {
    playPauseFunction();
});

function playPauseFunction() {
    toggleIconPlayPause(audioPlayer['0'].paused);

    if (audioPlayer['0'].paused === true) {
        audioPlayer['0'].play();
        togglePlayPause();
        trackInformations();
        currentPlaying.slideDown();
    }
    else {
        audioPlayer['0'].pause();
        togglePlayPause();
        togglePlayPauseList();
    }
}

nextButton.click(function () {
    audioPlayer['0'].pause();
    nextTrack();
});

previousButton.click(function () {
    audioPlayer['0'].pause();
    previousTrack();
});

/** end commande player header **/

/** audio player next and previous functions **/

// Load next track and updates the UI.
// Use dest = 'this' as call(this, 'this') to go the clicked items
// Use nextTrack() to go to the next playlist item. If the current
// playlist item is the last, it will go to the first.
function nextTrack(dest) {
    // Toggle Play/Pause button if paused
    if (playButton.is(':visible')) {
        togglePlayPause();
    }
    // Update UI
    currentSong.toggleClass('active');
    // Set default value for dest
    if (dest !== 'this') {
        dest = 'next';
    }
    // Update active playlist item NEXT
    if (dest === 'next') {
        if (currentSong.is(':last-child')) {
            currentSong = $('.playlist-item').first();
        } else {
            currentSong = currentSong.next();
        }
    }
    // Update active playlist item THIS
    else if (dest === 'this') {
        currentSong = $(this);
    }
    toggleIconPlayPause(audioPlayer['0'].paused);
    // Update src and UI
    audioPlayer['0'].pause();

    //count play
    countPlayPlayer(currentSong);

    currentSong.toggleClass('active');

    trackInformations();
    audioPlayer.attr('src', currentSong.attr('audio_url'));
    //thumbnail.css('max-width','200px');

    // Reset time and play
    audioPlayer['0'].currentTime = 0;
    $(document).ready(function () {
        audioPlayer['0'].play();
        togglePlayPauseList();
    })
}

// Load previous track and updates the UI.
// Use dest = 'this' as call(this, 'this') to go the clicked items
// Use previousTrack() to go to the previous playlist item. If the current
// playlist item is the last, it will go to the first last.
function previousTrack(dest) {
    // Toggle Play/Pause button if paused
    if (playButton.is(':visible')) {
        togglePlayPause();
    }
    // Update UI
    currentSong.toggleClass('active');
    // Set default value for dest
    if (dest !== 'this') {
        dest = 'previous';
    }
    // Update active playlist item PREVIOUS
    if (dest === 'previous') {
        if (currentSong.is(':first-child')) {
            currentSong = $('.playlist-item').last();
        } else {
            currentSong = currentSong.prev();
        }
    }
    // Update active playlist item THIS
    else if (dest === 'this') {
        currentSong = $(this);
    }
    toggleIconPlayPause(audioPlayer['0'].paused);
    // Update src and UI
    audioPlayer['0'].pause();

    //count play
    countPlayPlayer(currentSong);

    currentSong.toggleClass('active');

    trackInformations();
    audioPlayer.attr('src', currentSong.attr('audio_url'));
    thumbnail.css('width', '100px');

    // Reset time and play
    audioPlayer['0'].currentTime = 0;
    $(document).ready(function () {
        audioPlayer['0'].play();
        togglePlayPauseList();
    });
}

/** end audio player next and previous functions **/

/** player stream **/
var playstream = $('#playstream');
var pausestream = $('#pausestream');
var nextstream = $('#nextstream');
var previousstream = $('#previousstream');

playstream.click(function () {
    audioPlayer['0'].play();
    togglePlayPauseList();
    playstream.css('display', 'none');
    pausestream.css('display', 'inline-block');
    toggleIconPlayPause(true);
});

pausestream.click(function () {
    audioPlayer['0'].pause();
    togglePlayPauseList();
    playstream.css('display', 'inline-block');
    pausestream.css('display', 'none');
    toggleIconPlayPause(false);
});

nextstream.click(function () {
    audioPlayer['0'].pause();
    nextTrack();
});

previousstream.click(function () {
    audioPlayer['0'].pause();
    previousTrack();
});

var volumeslider = $('#volumeSlider').slider({
    //step: 0.01,
    value: 60,
    orientation: "horizontal",
    range: "min",
    animate: true
});

function volume(value) {
    $("#audio-player").prop("volume", value);
}

volumeslider.on('slidechange', function (event, ui) {
    volume(ui.value / 100);
});

/** end player stream **/

function toggleIconPlayPause(statusPause) {
    if (statusPause === true) {
        $('.play-pause').text('pause_circle_outline');
        playstream.css('display', 'none');
        pausestream.css('display', 'inline-block');
    } else {
        $('.play-pause').text('play_circle_outline');
        playstream.css('display', 'inline-block');
        pausestream.css('display', 'none');
    }
}

//  SLIDER

var timerstream = $('#timerstream').slider({step: 0.01});

var slider = $('.progress-bar').slider();

audioPlayer.on('timeupdate', function () {
    slider.slider("option", "value", this.currentTime / this.duration * 100);
});
//  changes playback time on slider input
slider.on('slidestop', function (event, ui) {
    var newTime = ui.value / 100 * audioPlayer['0'].duration;
    audioPlayer['0'].currentTime = newTime;
});

// Go to next track when track has ended
audioPlayer.bind('ended', function () {
    nextTrack();
});

var parentDiv = currentSong.parent('ul').parent('div').attr('id');
/*shufflestream.click(function () {
    alert(parentDiv);
});*/

var player = document.getElementById('audio-player');
player.addEventListener("timeupdate", function () {
    var currentTime = player.currentTime;
    var duration = player.duration;
    var progressBar = $('#player-range');
    /*var ratio = X / progressBar.width();
     var newCurrentTime = ratio * duration.
     player.currentTime = newCurrentTime;*/
    $('#player-range').stop(true, true).animate({'width': (currentTime + .25) / duration * 100 + '%'}, 250, 'linear');
});


