function addCache() {
  // $("body").append("<div class='loader-container'><span class='loader-xbox'></span></div>")
  $("body").append("<div id='wainting' style='position: fixed; background: rgba(0,0,0,0.7); z-index: 9999; width: 100%; height: 100%; top:0; left:0; display: flex; align-items: center;justify-content: center;'><p class='spinner loading'></p></div>")
}

function removeCache() {
  $("#wainting").remove();
}


(function ($) {
  'use strict';

  window.app = {
    name: 'pulse',
    setting: {
      folded: false,
      container: false,
      color: 'danger',
      bg: 'dark'
    }
  };

  var setting = 'jqStorage-' + app.name + '-Setting',
    storage = $.localStorage,
    color;


  var v = window.location.search.substring(1).split('&');
  for (var i = 0; i < v.length; i++) {
    var n = v[i].split('=');
    app.setting[n[0]] = (n[1] == "true" || n[1] == "false") ? (n[1] == "true") : n[1];
    storage.set(setting, app.setting);
  }

  setTheme();

  // init
  function setTheme() {

    $('body').removeClass($('body').attr('data-ui-class')).addClass(app.setting.bg).attr('data-ui-class', app.setting.bg);
    app.setting.folded ? $('#aside').addClass('folded') : $('#aside').removeClass('folded');
    $('#aside').length == 0 && (app.setting.container ? $('.app-header .navbar, .app-content').addClass('container') : $('.app-header .navbar, .app-content').removeClass('container'));

    $('.switcher input[value="' + app.setting.color + '"]').prop('checked', true);
    $('.switcher input[value="' + app.setting.bg + '"]').prop('checked', true);

    $('[data-target="folded"] input').prop('checked', app.setting.folded);
    $('[data-target="container"] input').prop('checked', app.setting.container);

    if (color != app.setting.color) {
      uiLoad.remove('css/theme/' + color + '.css');
      uiLoad.load('css/theme/' + app.setting.color + '.css');
      color = app.setting.color;
    }
  }

  // click to switch
  $(document).on('click.setting', '.switcher input', function (e) {
    var $this = $(this), $target;
    $target = $this.parent().attr('data-target') ? $this.parent().attr('data-target') : $this.parent().parent().attr('data-target');
    app.setting[$target] = $this.is(':checkbox') ? $this.prop('checked') : $(this).val();
    storage.set(setting, app.setting);
    setTheme(app.setting);
  });

})(jQuery);
